% ===   ***** ***** ***** ***** ***** ***** *****  	=== %
% ===   BE_LEAFNODE.M -> LET A NODE BE LEAFNODE     === %
% ===   ***** ***** ***** ***** ***** ***** *****  	=== %
% ===   UPDATED: 30 OCTOBER,  2015                  === %
% ===   ***** ***** ***** ***** ***** ***** *****  	=== %

function [] = be_leafnode(idx)
% INPUT:  IDX - THE NODE(S) THAT SHOULD BE RE-INITIALIZED AS LEAF(S)

global BSPTREE;
lenx = length(idx);

for i = 1 : lenx
    % SIGN OF BEING A LEAFNODE:
    %   1)D = 0; 
    %   2)BOTH ITS LEFT & RIGHT CHILDREN POINT TO .LAST
    BSPTREE.d(1, idx(i)) = 0;
    BSPTREE.l_idx(1, idx(i)) = BSPTREE.last;
    BSPTREE.r_idx(1, idx(i)) = BSPTREE.last;
    BSPTREE.min(1, idx(i)) = 0;
    BSPTREE.max(1, idx(i)) = 0;
    % NOTE THAT THE REST INFORMATION, E.G., X, F, ETC.
    % WOULD BE COVERED BY NEW INFORMATION.
end

end