% ===   ***** ***** ***** ***** ***** ***** *****  	=== %
% ===   GET_PRUNE_LIST LRU PRUNING                  === %
% ===   ***** ***** ***** ***** ***** ***** *****  	=== %
% ===   UPDATED: 24 MAY, 2015                       === %
% ===   ***** ***** ***** ***** ***** ***** *****  	=== %

function [prune_list] = get_prune_list_p()

global BSPTREE;
prune_list = [];
prune_ts   = [];
s = [];
idx = 1;

while (BSPTREE.ts(1, idx) < inf && BSPTREE.r_idx(1, idx) > 0) || (~ isempty(s))
    while BSPTREE.ts(1, idx) < inf
        if (~ BSPTREE.d(1, idx)) && (~ BSPTREE.vn(1, idx))
        % IF LEAF NODE && DIFFERENT FROM ITS PARENT %
            prune_list = [prune_list, idx];
            prune_ts   = [prune_ts, BSPTREE.ts(1, idx)];
        end
        s = [s, idx];
        idx = BSPTREE.l_idx(1, idx);
    end
    if ~ isempty(s)
        idx = s(end);
        s(end) = [];
        idx = BSPTREE.r_idx(1, idx);
    end
end  % END OF OUTSIDE WHILE %

[~, sort_idx] = sort(prune_ts);
prune_list = prune_list(sort_idx);

if isempty(prune_list)
    error('NO LRU NODE ... ');
end
    
end