% ===   ***** ***** ***** ***** ***** ***** *****  	=== %
% ===   PRUNE_AND_REINSERT_P.M -> FOR LRU PRUNING	=== %
% ===   ***** ***** ***** ***** ***** ***** *****  	=== %
% ===   UPDATED: 23 MAY, 2015                       === %
% ===   ***** ***** ***** ***** ***** ***** *****  	=== %

function [prune_list] = prune_and_reinsert_p(prune_list, x, f, ts_begin)
% === === === === === === === === === %
% INPUT:   1) PRUNE_LIST - THE TO-PRUNE-LIST
%          2) X          - SOLUTION
%          3) F          - FITNESS
%          4) TS_BEGIN   - TIME STAMP
% OUTPUT:  1) PRUNE_LIST - THE UPDATED TO-PRUNE-LIST 
% === === === === === === === === === %

global BSPTREE;

node_idx = prune_list(1);
prune_list(1) = [];

[sibling, is_leaf] = find_sibling(node_idx);
p_idx = BSPTREE.p_idx(1, node_idx);

if is_leaf  % IF SIBLING IS LEAF, THEN MERGE (PRUNE) AND RE-INSERT NEW NODE %
    free_pos = sort([node_idx, sibling]);
    bsptree_delete_node(free_pos);
    be_leafnode(p_idx);
    [~, add] = bsptree_insertion_p(x, f, ts_begin, NaN, free_pos);
else  % IF NOT, THEN RE-ORGANIZE THE SUBTREE, AND THEN INSERT NEW NODE %
    free_pos = re_organize_subtree(sibling);
    [~, add] = bsptree_insertion_p(x, f, ts_begin, NaN, free_pos);
end
prune_list(prune_list == add) = [];
    
end