% ===   ***** ***** ***** ***** ***** ***** *****  	=== %
% ===   RE_ORGANIZE_SUBTREE                         === %
% ===   ***** ***** ***** ***** ***** ***** *****  	=== %
% ===   UPDATED: 24 MAY, 2015                       === %
% ===   ***** ***** ***** ***** ***** ***** *****  	=== %

function [free_pos] = re_organize_subtree(sibling)
% === === === === === === === === === %
% INPUT:   SIBLING  - THE SIBLING OF TO-PRUNE-LEAFNODE
% OUTPUT:  FREE_POS - THE ADDRESS OF NODE BEEN PRUNED
% === === === === === === === === === %

global BSPTREE;

p_idx = BSPTREE.p_idx(1, sibling);
lrv_idx = find_sibling(sibling);

BSPTREE.l_idx(p_idx) = BSPTREE.l_idx(sibling);
BSPTREE.r_idx(p_idx) = BSPTREE.r_idx(sibling);

BSPTREE.p_idx(BSPTREE.l_idx(sibling)) = p_idx;
BSPTREE.p_idx(BSPTREE.r_idx(sibling)) = p_idx;

d_diff = abs(BSPTREE.x(:, BSPTREE.l_idx(sibling)) - BSPTREE.x(:, BSPTREE.r_idx(sibling)));
d = find(d_diff == max(d_diff));
% % % if length(d) > 1
% % %     d = d(ceil(rand * length(d)));
% % % end
d = d(1);
BSPTREE.d(1, p_idx) = d;

BSPTREE.min(1, p_idx) = min(BSPTREE.x(d, BSPTREE.l_idx(sibling)), BSPTREE.x(d, BSPTREE.r_idx(sibling)));
BSPTREE.max(1, p_idx) = max(BSPTREE.x(d, BSPTREE.l_idx(sibling)), BSPTREE.x(d, BSPTREE.r_idx(sibling)));

free_pos = sort([sibling, lrv_idx]);
bsptree_delete_node(free_pos);

end